<template>
  <div id="pageDashboard">
    <div>
      <v-toolbar dark color="purple" dense>
        <v-toolbar-title class="white--text">Elección 2020</v-toolbar-title>
        <v-spacer></v-spacer>
        <v-list-tile to="Login" ripple="ripple" rel="noopener">
          <v-list-tile-action>
            <v-icon>lock</v-icon>
          </v-list-tile-action>
          <v-list-tile-content>
            <v-list-tile-title>Entrar</v-list-tile-title>
          </v-list-tile-content>
        </v-list-tile>
        <v-btn icon></v-btn>
      </v-toolbar>
    </div>
    <v-container grid-list-xl fluid>
      <v-layout row wrap>
        <!-- mini statistic start -->
        <v-flex lg4 sm6 xs12>
          <mini-statistic
            icon="person"
            title="Candidato 1"
            :number="statistic.candidate1"
            sub-title="Votos"
            color="primary"
          ></mini-statistic>
        </v-flex>
        <v-flex lg4 sm6 xs12>
          <mini-statistic
            icon="person"
            title="Candidato 2"
            :number="statistic.candidate2"
            sub-title="Votos"
            color="info"
          ></mini-statistic>
        </v-flex>
        <v-flex lg4 sm6 xs12>
          <mini-statistic
            icon="person"
            title="Candidato 3"
            :number="statistic.candidate3"
            sub-title="Votos"
            color="warning"
          ></mini-statistic>
        </v-flex>
        <!-- mini statistic  end -->
      </v-layout>
      <v-divider></v-divider>
      <v-card-text class="pa-0">
        <v-data-table
          :headers="headers"
          :items="votes"
          class="elevation-1"
          :rows-per-page-items="[100,300,500,{text: `${$t('translations.dataIterator.rowsPerPageAll')}`,'value':-1}]"
          :rows-per-page-text="$t('translations.dataTable.rowsPerPageText')"
          loading-text="Loading... Please wait"
        >
          <template slot="items" slot-scope="props">
            <td>{{ props.item.previousHash}}</td>
            <td>{{ props.item.hash}}</td>
            <td>{{ props.item.address}}</td>
            <td>{{ props.item.voto}}</td>
            <td>{{ props.item.nonce}}</td>
            <td>{{ props.item.difficulty}}</td>
            <td>{{getDate(props.item.timestamp) }}</td>
          </template>
          <template
            slot="pageText"
            slot-scope="item"
          >{{item.pageStart}} - {{item.pageStop}} {{$t('translations.dataTable.of')}} {{item.itemsLength}}</template>
        </v-data-table>
      </v-card-text>
    </v-container>
  </div>
</template>

<script>
// import VWidget from "@/components/VWidget";
// import Pusher from "pusher-js"; // import Pusher
// import EventBus from '@/event-bus'
import _ from "lodash";
import Material from "vuetify/es5/util/colors";
import MiniStatistic from "@/components/widgets/statistic/MiniStatistic";
import moment from "moment";
import momentTimezone from "moment-timezone";

//Providers
import BlockchainProvider from "@/providers/Blockchain";
const BlockchainResource = new BlockchainProvider();

export default {
  components: {
    MiniStatistic
    //VWidget
  },
  data: () => ({
    color: Material,
    loading: false,
    locations_permission: [],
    providers_permission: [],
    statistic: {
      candidate1: 0,
      candidate2: 0,
      candidate3: 0
    },
    votes: [],
    search: "",
    items: [],
    message: []
  }),
  created() {},
  mounted() {
    this.getBlocks();
    // const pusher = new Pusher("56b3197e46007d83dded");
    // pusher.subscribe("dash", channel => {
    //   channel.bind(this.getBlocks(), ({ result }) => {
    //     console.log(result);
    //   });
    // });
    // const pusher = new Pusher('56b3197e46007d83dded', {
    //   cluster: 'us2',
    //   enabledTransports: ["ws"]
    // });

    // pusher.connection.bind("error", function(err) {
    //   if (err.error.data.code === 4004) {
    //     console.log("Over limit!");
    //   }
    // });
  },
  computed: {
    headers() {
      let _headers = [
        {
          text: "Previous Hash",
          value: "Previous Hash"
        },
        {
          text: "Hash",
          value: "Hash"
        },
        {
          text: "Address",
          value: "Address"
        },
        {
          text: "Voto",
          value: "Voto"
        },
        {
          text: "Nonce",
          value: "Nonce"
        },
        {
          text: "Difficulty",
          value: "Difficulty"
        },
        {
          text: "Fecha",
          value: "Fecha"
        }
      ];
      return _headers;
    }
  },
  methods: {
    getBlocks() {
      let self = this;
      BlockchainResource.getBlocks()
        .then(response => {
          // console.log(this.votes);
          _.map(response.data, function(item, index) {
            if (index > 0) {
              self.votes.push(item);
            }

            switch (item.voto) {
              case 1:
                self.statistic.candidate1 += 1;
                break;
              case 2:
                self.statistic.candidate2 += 1;
                break;
              case 3:
                self.statistic.candidate3 += 1;
                break;
            }
          });
        })
        .catch(error => console.log(error));
    },
    getDate(timestamp) {
      return moment(timestamp).format("YYYY-MM-DD HH:mm:ss");
    }
  }
};
</script>
